/*

  in_cube Gamecube Stream Player for Winamp
  by hcs

  includes work by Destop and bero

*/

// VAG

#include <windows.h>
#include "wamain.h"
#include "cube.h"

// inputfile == NULL means file is already opened, just reload
// return 1 if valid VAG not detected, 0 on success
int InitVAGFILE(char * inputfile, CUBEFILE * vag) {
	int l;
	char readbuf[0x40];
	if (inputfile) {
		vag->ch[0].infile=vag->ch[1].infile=INVALID_HANDLE_VALUE;

		if (strcmpi(inputfile+strlen(inputfile)-4,".vag")) return 1;

		vag->ch[0].infile = CreateFile(inputfile,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
			OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

		if (vag->ch[0].infile == INVALID_HANDLE_VALUE) // error opening file
			return 1;

	} else if (vag->ch[0].type!=type_vag) return 1; // we don't have the file name to recheck

	vag->ch[0].type=type_vag;

	ReadFile(vag->ch[0].infile,readbuf,0x40,&l,NULL);

	vag->NCH = 1;
	vag->ch[0].sample_rate = get32bit(readbuf+0x10);
	vag->ch[0].loop_flag=0;
	vag->nrsamples = get32bit(readbuf+0xc)*28/16;
	vag->ch[0].chanstart=0x40;

	vag->file_length=GetFileSize(vag->ch[0].infile,NULL)-0x40;

	vag->ch[0].hist1 = 0;
    vag->ch[0].hist2 = 0;
    vag->ch[1].hist1 = 0;
    vag->ch[1].hist2 = 0;

	vag->ch[0].readloc=vag->ch[1].readloc=vag->ch[0].writeloc=vag->ch[1].writeloc=0;

	SetFilePointer(vag->ch[0].infile,vag->ch[0].chanstart,0,FILE_BEGIN);

	return 0;
}

void fillbufferVAG(CUBEFILE * vag) {
	int l;
	char ADPCMbuf[16];

	if ((signed long)SetFilePointer(vag->ch[0].infile,0,0,FILE_CURRENT) >= vag->file_length) {
		vag->ch[0].readloc=vag->ch[0].writeloc-1;
		return;
	}

	do {
		ReadFile(vag->ch[0].infile, ADPCMbuf, 16, &l, NULL);
		if (l<16) return;
		VAGdecodebuffer(ADPCMbuf,vag->ch[0].chanbuf+vag->ch[0].writeloc,
					&vag->ch[0].hist1, &vag->ch[0].hist2);

		vag->ch[0].writeloc+=28;

		if (vag->ch[0].writeloc>=0x8000/8*14) vag->ch[0].writeloc=0;
	} while (vag->ch[0].writeloc != vag->ch[0].readloc);
}

